% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/methods-MixtureModel.R
\docType{methods}
\name{mcmcParams}
\alias{mcmcParams}
\alias{mcmcParams<-}
\alias{mcmcParams,MixtureModel-method}
\alias{mcmcParams<-,MixtureModel-method}
\alias{mcmcParams,MixtureModel-method}
\alias{mcmcParams<-,list-method}
\alias{mcmcParams,list-method}
\alias{mcmcParams,list-method}
\title{Retrieve MCMC parameters from model.}
\usage{
mcmcParams(object)

mcmcParams(object, force = FALSE) <- value

\S4method{mcmcParams}{MixtureModel}(object)

\S4method{mcmcParams}{MixtureModel}(object, force = TRUE) <- value

\S4method{mcmcParams}{list}(object, force = TRUE) <- value

\S4method{mcmcParams}{list}(object)
}
\arguments{
\item{object}{see \code{showMethods(mcmcParams)}}

\item{force}{logical value. If false (default) the update will not proceed.}

\item{value}{an object of class 'McmcParams' containing the new number of iterations, etc.}
}
\value{
An object of class 'McmcParams'
}
\description{
View number of iterations, burnin, etc.

Replace number of iterations, burnin, etc. Any update of the MCMC parameters will trigger an update of the chains. However, if iter (the number of MCMC iterations) is set to a nonpositive value, the chains will not be updated and kept as is.
}
\examples{
     mcmcParams(SingleBatchModelExample)
}
